#include<stdio.h>
#include<time.h>
#define max_num 100
#define PRINT 0
void swap(int* a, int* b)
{
	int c;
	c=*a;
	*a=*b;
	*b=c;
}

void inverse(int perm_str[],int index,int perm_num)
{
	int mid=(index+perm_num)/2;
	int i,j;
	
	for(i=index;i<=mid;i++)
		swap(&perm_str[i],&perm_str[perm_num-(i-index)]);
}

int findlarger(int perm_str[],int perm_num,int index)
{
	int i,larger_index=0,tmp_index;
	for(i=index+1;i<=perm_num;i++)
	{
		if(perm_str[i]>perm_str[index])
		{
			tmp_index=i;
			
			if(perm_str[tmp_index<perm_str[larger_index]])
				larger_index=tmp_index;
				
		}
		
	}
	return larger_index;
}


void printf_perm(int perm_str[],int perm_num)
{
	int i;
	for(i=1;i<=perm_num;i++)
		printf("%d ",perm_str[i]);
	printf("\n");
}

int main(int argc,char *argv[])
{
	clock_t start, end;
	int i,perm_all_num=0;
	int perm_str[max_num+1];
	int sort_flag;
	int perm_num=atoi(argv[1]);
	
	if(perm_num>max_num || argc>2 ||perm_num<1)
	{
		printf("Too large");
		return 1;
		
	}
	start = clock();
	perm_str[0]=perm_num;
	for(i=1;i<=perm_num;i++)//can improve
		perm_str[i]=i;
	if(PRINT)
		printf_perm(perm_str,perm_num);
	perm_all_num++;
	
	
	while(1)
	{
		sort_flag=0;
		for(i=perm_num-1;i>0;i--)
		{
			if(perm_str[i]<perm_str[i+1])
			{
				sort_flag=1;
				//find lager than this
				int larger_index=findlarger(perm_str,perm_num,i);
			
				//swap
				swap(&perm_str[i],&perm_str[larger_index]);
			

				//inverse		
				inverse(perm_str,i+1,perm_num);
				
				if(PRINT)
					printf_perm(perm_str,perm_num);		
				break;
			}
		}
		
		if(sort_flag==0)
		{
			break;
		}
		else
			perm_all_num++;
	}

	end = clock();
	printf("time:%f\n", difftime(end, start));
	printf("perm num is %d\n",perm_all_num);

	return 0;
}
