#include<stdio.h>
#include<time.h>
#include<string.h>
#define max_num 50

#define PRINT 0

#define swap(a,b) {int t=a; a=b; b=t;}

int table_in[max_num+1];
int table_out[max_num+1];

void inverse(int perm_str[],int index,int perm_num)
{
	int mid=(index+perm_num)/2;
	int i;
	
	for(i=index;i<=mid;i++)
		swap(perm_str[i],perm_str[perm_num-(i-index)]);
}

void findlarger_swap(int perm_str[],int perm_num,int index)
{
	int i,larger_index=0,tmp_index,tmp,index_value;
	for(i=index+1;i<=perm_num;i++)
	{
		tmp=perm_str[larger_index];
		index_value=perm_str[index];
		if(perm_str[i]> index_value && perm_str[i]<tmp)
		{
				larger_index=i;
							
		}
		
	}
	swap(perm_str[index],perm_str[larger_index]);
}


void printf_perm(int perm_str[],int perm_num,int perm_all_num)
{

	
	int i;
	for(i=1;i<=perm_num;i++)
		printf("%d ",perm_str[i]);
	printf("\n");

	int p=perm_num+1;
	for(i=1;i<=perm_num;i++)
		printf("%d ",p-perm_str[i]);
	printf("\n");
}


int getPerm_n(int n)
{


	int sum=1,j;
	for(j=1;j<=n;j++)
		sum=sum*j;
	return sum;
}
int main(int argc,char *argv[])
{
	clock_t start, end;
	int i,j,perm_in,perm_all_num=0,perm_now_num=0;
	int perm_str[max_num+1];
	int perm_str1[max_num+1];
	int perm_str0[max_num+1];
	int sort_flag;
	int perm_num=atoi(argv[1]);
	int improved_n=2;
	int flag=0;
	if(perm_num>max_num || argc>2 ||perm_num<1)
	{
		printf("Too large");
		return 1;
		
	}
	
	if(perm_num==1)
	{
		printf("1\n");
		return 0;
	}
	else if(perm_num==2)
	{
		printf("1 2\n2 1\n");
		return 0;
		
	}
	start = clock();
	perm_str[0]=perm_num+1;
	for(i=1;i<=perm_num;i++)//can improve
		perm_str[i]=i;
	memcpy(perm_str0, perm_str,(perm_num+1)*sizeof(perm_str[1]));
	
	perm_all_num=getPerm_n(perm_num);
	perm_in=perm_all_num/perm_num;
	
	//print
	if(PRINT)
		printf_perm(perm_str,perm_num,perm_all_num);
	//create table_in
	//table_in[1]=perm_str[1];
	for(i=2;i<=perm_num;i++)
		table_in[perm_str[i]]=perm_str[perm_num+2-i];
	for(i=2;i<=perm_num;i++)
		perm_str1[i]=table_in[perm_str[i]];
	perm_str1[1]=perm_str[1];
	
	//print
	if(PRINT)		
		printf_perm(perm_str1,perm_num,perm_all_num);
	int p=perm_num-1;
	int q=perm_num/2;
	int larger_index;
	sort_flag=2;
	
	if(perm_num==q*2)
	{
	for(j=1;j<=q;j++)
	{
		while(1)
		{
			if(sort_flag>=perm_in)
				break;
			for(i=p;i>0;i--)
			{
				if(perm_str[i]<perm_str[i+1])
				{
				sort_flag=sort_flag+2;
				//find lager than this and swap
				findlarger_swap(perm_str,perm_num,i);
			
				//inverse	
				inverse(perm_str,i+1,perm_num);
				
				if(PRINT)
					printf_perm(perm_str,perm_num,perm_all_num);
				//perm_str1
				for(i=2;i<=perm_num;i++)
					perm_str1[i]=table_in[perm_str[i]];
				perm_str1[1]=perm_str[1];
				
				if(PRINT)
					printf_perm(perm_str1,perm_num,perm_all_num);
				break;	
				}	
			}

		}
		
		//get anather perm begin with i+1
		if(j<q)
		{
		
		memcpy(&perm_str[j+1], &perm_str0[j+1],(perm_num-j-1)*sizeof(perm_str[1]));
		int k;
		for(k=1;k<=j;k++)
			perm_str[k+1]=perm_str0[k];
		perm_str[1]=j+1;
		
		if(PRINT)
			printf_perm(perm_str,perm_num,perm_all_num);			
			//create table_in
			table_in[1]=perm_str[1];
			for(i=2;i<=perm_num;i++)
				table_in[perm_str[i]]=perm_str[perm_num+2-i];
			for(i=2;i<=perm_num;i++)
				perm_str1[i]=table_in[perm_str[i]];
			perm_str1[1]=perm_str[1];
			if(PRINT)	
				printf_perm(perm_str1,perm_num,perm_all_num);	
		}
		sort_flag=2;
		
	}
	
	}
	
	//for ji
	
	else
	{
	
	sort_flag=2;

	for(j=1;j<=q;j++)
	{
		while(1)
		{
			if(sort_flag>=perm_in)
				break;
			for(i=p;i>0;i--)
			{
				if(perm_str[i]<perm_str[i+1])
				{
				sort_flag=sort_flag+2;
				//find lager than this
				findlarger_swap(perm_str,perm_num,i);
		
		
				//inverse		
				inverse(perm_str,i+1,perm_num);
				
				if(PRINT)
					printf_perm(perm_str,perm_num,perm_all_num);
				//perm_str1
				for(i=2;i<=perm_num;i++)
					perm_str1[i]=table_in[perm_str[i]];
				perm_str1[1]=perm_str[1];
				
				if(PRINT)
					printf_perm(perm_str1,perm_num,perm_all_num);
				break;	
				}	
			}

		}
		
		//get anather perm begin with i+1
		if(j<q)
		{	
		memcpy(&perm_str[j+1], &perm_str0[j+1],(perm_num-j)*sizeof(perm_str[1]));
		int k;
		for(k=1;k<q;k++)
			perm_str[k+1]=perm_str0[k];
		perm_str[1]=j+1;
			
		if(PRINT)
			printf_perm(perm_str,perm_num,perm_all_num);
		
		if(perm_in>2)
		{
				//create table_in
			table_in[1]=perm_str[1];
			for(i=2;i<=perm_num;i++)
				table_in[perm_str[i]]=perm_str[perm_num+2-i];
			for(i=2;i<=perm_num;i++)
				perm_str1[i]=table_in[perm_str[i]];
			perm_str1[1]=perm_str[1];
			if(PRINT)	
				printf_perm(perm_str1,perm_num,perm_all_num);	
		}
		}
		sort_flag=2;
		
	}
	
		//q+1
		memcpy(&perm_str[q+1], &perm_str0[q+1],(perm_num-q)*sizeof(perm_str[1]));
		int k;
		for(k=1;k<=q;k++)
			perm_str[k+1]=perm_str0[k];
		perm_str[1]=q+1;
		if(PRINT)	
				printf_perm(perm_str,perm_num,perm_all_num);
				
		sort_flag=2;
		while(1)
		{

			if(sort_flag>=perm_in)
				break;
			for(i=p;i>0;i--)
			{
				if(perm_str[i]<perm_str[i+1])
				{
				sort_flag=sort_flag+2;
				//find lager than this
				findlarger_swap(perm_str,perm_num,i);
			

				//inverse		
				inverse(perm_str,i+1,perm_num);
				
				if(PRINT)
					printf_perm(perm_str,perm_num,perm_all_num);
				break;	
				}	
			}

		}
		
	
	}
	end = clock();
	printf("time:%f\n", difftime(end, start));
	printf("perm num is %d\n",perm_all_num);

	return 0;
}
